CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRLB, CR, #16, CLS      ' PST formmatting control
  MTR_STBY      = 20
  MTR1PWM       = 17
  MTR1A         = 18
  MTR1B         = 19
  MTR2PWM       = 23
  MTR2A         = 21
  MTR2B         = 22
  MTR_FREQ      = 10000
  MTR_RAMP_STEP = 10
  LED = -1
  SENSOR = 0
  NUMBER = 8
  GO_PIN = 15                   ' pushed is 0 not pushed is 1                        
  LED_PIN = 14
  CAL_PIN = 27                  ' switch 1 on dip on is calibrate, off is read calibration
  WB_PIN = 26                   ' switch 2 on dip on is white line off is black line
  SP1_PIN = 25                  ' switch 3 on dip 0=on 1=off  off-off-> 0 off-on->2 on-off->1 on-on->3
  SP2_PIN = 24                  ' switch 4 on dip 0=on 1=off   3   4       3   4     3  4
  PE =  60                      ' to reduce Pgain make PE bigger
  PINT = 0
  PD =   5                       ' pololu  1/20 1/10,000 2/3
  ' curse is 92 inches long        
OBJ
  Sio  : "Parallax Serial Terminal"        
  Mtr : "TB6612FNG"
  LS : "PololuQTR"

VAR
  long baseSpeed, cycleTime, linePos, e, oldE, de, integral, totalerror,cycles
  byte WhiteLine  
Pub Main | i
'  Sio.start(31,30,0,115200)  ' Rx,Tx, Mode, Baud
  Sio.startRxTx(8,9,0,115200)  ' Rx,Tx, Mode, Baud      XBee
  dira[LED_PIN]~~
  outa[LED_PIN]~
  dira[GO_PIN]~
  cycleTime := clkfreq / 50
  Mtr.Start(MTR_STBY,MTR1PWM,MTR1A,MTR1B,MTR2PWM,MTR2A,MTR2B,MTR_FREQ,MTR_RAMP_STEP)
  LS.Start(LED, SENSOR, NUMBER)
  If ina[WB_PIN] == 0
    WhiteLine := TRUE
  else
    WhiteLine := FALSE
  if ina[CAL_PIN] == 0
    Calibrate
  else
    i := LS.ReadCalibration
    if i < 2                                            ' not calibrated
      repeat 10
        !outa[LED_PIN]
        waitcnt(clkfreq/2 + cnt)
      abort
    repeat
      totalError := 0
      cycles := 0
      repeat until ina[GO_PIN] == 0    
      baseSpeed := speedTable[3 - ina[24..25]]
      sio.char(0)
      sio.dec(basespeed)
      sio.char(13)
      Mtr.EnableMotors
      Run
      Mtr.Coast
      sio.dec(totalError)
      sio.char(9)
      sio.dec(cycles)
      sio.char(9)
      sio.dec(totalError/cycles)
      sio.char(13)
PUB Run  | delay, steer, sensorState
  outa[LED_PIN]~~
  delay := cnt
  repeat
    delay += cycletime
    cycles ++
    e := 3500 - LS.LinePos(LS#QTR_EMITTERS_ON, WhiteLine)
    e += 3500 - LS.LinePos(LS#QTR_EMITTERS_ON, WhiteLine)
    e ~>= 1
    sensorState := LS.GetSensorstate ' line left 10000000 line right 0000001
    de := e - oldE
    integral += e
    oldE := e
    steer := e / PE + integral / PINT + de / PD
    steer :=  -baseSpeed #> steer <# baseSpeed
      Mtr.SetSpeed(baseSpeed + steer, baseSpeed - steer)
{    if steer < 0
      Mtr.SetSpeed(baseSpeed + steer, baseSpeed)
    else
      Mtr.SetSpeed(baseSpeed, BaseSpeed - steer)  }
    totalError += || e   
    sio.dec(e)
    sio.Char(44)
    sio.dec(integral)
    sio.Char(44)
    sio.dec(de)
    sio.Char(44)
    sio.bin(sensorState,8)
    sio.Char(44)
    sio.dec(steer)   
    sio.Char(13)
    if LS.Stop(200, WhiteLine)
'    if sensorState == $FF
      outa[LED_PIN]~
      return
    waitcnt(delay)
     
PUB Calibrate
  repeat until ina[GO_PIN] == 0
  outa[LED_PIN]~~
  LS.Calibrate(LS#QTR_EMITTERS_ON, 25)
  LS.SaveCalibration
  outa[LED_PIN]~
  return

DAT
        speedTable long  25, 50, 75, 100  