VAR long parameter
    long mtr1Pwr, mtr2Pwr, diraval, ctraval, ctrbval, period, mtr1PWM, mtr2PWM, stby
    long frame[400]
    long center, pwrStep, lMtr, rMtr,mtr1PwrOld, mtr2PwrOld, rampStep

PUB Start(_stby,_mtr1PWM,_mtr1A,_mtr1B,_mtr2PWM,_mtr2A,_mtr2B,_freq,_rampStep)
'' If motors go the wrong direction, either change motor leads or
'' switch A and B pins in call to start
  stby := _stby
  dira[stby]~~                  ' output
  outa[stby]~                   ' stby low motor not enabled
  mtr1PWM := _mtr1PWM
  dira[mtr1PWM]~~                 ' output
  outa[mtr1PWM]~~                 ' high
  mtr2PWM := _mtr2PWM
  dira[mtr2PWM]~~                 ' output
  outa[mtr2PWM]~~                 ' high
  diraval |=  |< _mtr1A  |  |< _mtr1B  |  |< _mtr2A  | |< _mtr2B
  period := clkfreq / _freq
  ctraval :=  00101 << 26 + (_mtr1A <<9) + _mtr1B
  ctrbval :=  00101 << 26 + (_mtr2A <<9) + _mtr2B
  mtr1Pwr := period / 2         ' 0 speed
  mtr2Pwr := period / 2
  mtr1PwrOld := mtr1Pwr
  mtr2PwrOld := mtr2Pwr
  center := period / 2
  pwrStep := period / 200
  rampStep := _rampStep
  cognew(@entry, @mtr1Pwr)
  
PUB SetSpeed(_mtr1Pwr, _mtr2Pwr)
{  speed is set -100 (full reverse), 0 (stop), 100 (full forward) }
  _mtr1Pwr := -100 #> _mtr1Pwr <# 100                   ' enforce limits
  _mtr2Pwr := -100 #> _mtr2Pwr <# 100 
  mtr1Pwr := center +  _mtr1Pwr * pwrStep
  mtr2Pwr := center +  _mtr2Pwr * pwrStep

PUB RampSpeed(_mtr1Pwr, _mtr2Pwr)
{{ Will increase or decrease motor power by rampStep each call until requested value is set.
   For example if current power is 0 and requested power is 100 and rampStep is 5, it will
   take 20 calls to reach requested power.  Purpose is to prevent abrupt power changes.  The
   -100, 100 limits enforced in SetSpeed }}
  _mtr1Pwr := (mtr1PwrOld - rampStep) #> _mtr1Pwr <# (mtr1PwrOld + rampStep) 
  mtr1PwrOld := _mtr1Pwr
  _mtr2Pwr := (mtr2PwrOld - rampStep) #> _mtr2Pwr <# (mtr2PwrOld + rampStep) 
  mtr2PwrOld := _mtr2Pwr
  SetSpeed(_mtr1Pwr, _mtr2Pwr)
  
PUB Brake
'' Short brake.  Must call ReleaseBrake to leave Break Mode
  mtr1Pwr := mtr2Pwr := center
  outa[mtr1PWM]~
  outa[mtr2PWM]~

PUB ReleaseBrake
  mtr1Pwr := mtr2Pwr := center
  outa[mtr1PWM]~~
  outa[mtr2PWM]~~

Pub EnableMotors
  outa[stby]~~

PUB Coast
'' motor driver outputs off--high impedance
'' must call EnableMotors to leave coast mode
  outa[stby]~
              
  
DAT
'assembly cog which updates the PWM cycle on APIN
'for audio PWM, fundamental freq which must be out of auditory range (period < 50S)
        org
entry   mov       t1,           par
        rdlong    mtr1,         t1                  ' get motor 1 duty in clock ticks 
        add       t1,           #4
        rdlong    mtr2,         t1                  ' likewise for motor 2 
        add       t1,           #4
        rdlong    outPins,      t1
        mov       dira,         outPins              'set direction pins to output
        add       t1,           #4
        rdlong    ctraV,        t1                   ' get counter a control value
        mov       ctra,         ctraV
        add       t1,           #4
        rdlong    ctrbV,        t1                   ' get counter b control value
        mov       ctrb,         ctrbV
        add       t1,           #4                   ' get period in clock ticks
        rdlong    periodV,      t1
        mov       frqa,         #1                   'set counter to increment 1 each cycle
        mov       frqb,         #1                   'set counter to increment 1 each cycle
        mov       time,         cnt                  'record current time
        add       time,         periodV              'establish next period
:loop   mov       t1,           par
        rdlong    mtr1,         t1                      ' get motor 1 duty in clock ticks
        add       t1,           #4                      
        rdlong    mtr2,         t1                      ' likewise for motor 2
        waitcnt   time,         periodV           'wait until next period
        neg       phsa,         mtr1              'back up phsa so that it
        neg       phsb,         mtr2              'back up phsb so that it
        jmp       #:loop                          'loop for next cycle
outPins res 1                   
ctraV   res 1          
ctrbV   res 1         
periodV res 1                                         
time    res 1
mtr1    res 1
mtr2    res 1
t1      res 1